Scriptname CF2DialogueQuest extends Quest 

ReferenceAlias[] property actors Auto
ReferenceAlias[] property aggressors Auto
ReferenceAlias property helpfollower Auto
ReferenceAlias property resquequestaggressor Auto
GlobalVariable property CFregisteramount Auto
GlobalVariable property CFswitch Auto
Idle[] property idles Auto
Package property donothing Auto
Faction[] property factions Auto ;factions[6] = dwarvenautomaton
Faction property prisonerfaction Auto
faction property currentfollowerfaction Auto
Faction Property playerfaction Auto
Faction property potentialfollowerfaction Auto
Faction property registerdfaction Auto
Keyword Property SexLabActive auto
SPELL Property Ability  Auto 
Quest property ResqueQuest Auto
int space
int currentvictimnumber
int[] idlesave
int activepoint

SexLabFramework SexLab

Event OnInit()
	SexLab = SexLabUtil.GetAPI()
	idlesave = new int[8]
	Game.GetPlayer().AddSpell(Ability)	
	Game.GetPlayer().SetFactionRank(playerfaction,4)
	RegisterForSingleUpdate(30)	
EndEvent

Function ChangePlayerFactionRank()
	Actor player = game.GetPlayer()	
	int power = activepoint - SexLab.SexCount(player)		

	if(power < -40)
		player.SetFactionRank(playerfaction,0)
	elseif(power < -18)		
		player.SetFactionRank(playerfaction,1)
	elseif(power < -8)
		player.SetFactionRank(playerfaction,2)
	elseif(power < -2)
		player.SetFactionRank(playerfaction,3)
	elseif(power < 3)
		player.SetFactionRank(playerfaction,4)
	elseif(power < 8)
		player.SetFactionRank(playerfaction,5)
	elseif(power < 18)
		player.SetFactionRank(playerfaction,6)
	elseif(power < 40)
		player.SetFactionRank(playerfaction,7)
	else
		player.SetFactionRank(playerfaction,8)
	endif
EndFunction

Function RegisterActor(Actor act)	
	int n = CFregisteramount.getvalueint()	
	actors[n].ForceRefTo(act)
	Utility.wait(0.5)		
	actors[n].GetActorReference().AddToFaction(registerdfaction)
	SetObjectiveDisplayed(n,true)
	CFregisteramount.SetValueInt(n + 1)
	debug.notification(CFregisteramount.getvalueint() + "/" + actors.length)	
EndFunction

Function StartResqueQuest(Actor act)	
	if(CFregisteramount.getvalueint() == 0)		
		return
	endif
	ResqueQuest.stop()
	ResqueQuest.start()
	While(!resquequestaggressor.GetReference())
		ResqueQuest.stop()
		ResqueQuest.start()
		utility.wait(0.5)
	endwhile

	int r = Utility.RandomInt(0,CFregisteramount.getvalueint() - 1)
	Actor victim = actors[r].GetActorReference()
	VictimMove(victim,resquequestaggressor.GetActorReference(),CheckInFaction(resquequestaggressor.GetActorReference()),r)
	debug.notification("Resque the Captive")
EndFunction

Function CheckMove()	
	if(CFregisteramount.getvalueint() == 0)		
		return
	endif
	Actor Player = Game.GetPlayer()		
	Actor target = Game.FindRandomActorFromRef(Player,10000)			
	int r = Utility.RandomInt(0,CFregisteramount.getvalueint() - 1)
	Actor victim = actors[r].GetActorReference()	
	if(!victim || victim.HasKeyWord(SexLabActive))		
		return
	endif	
	
	if(target && victim != target && !target.IsInFaction(prisonerfaction) && victim.GetDistance(target) > 5000.0)		
		int f = CheckInFaction(target)
		int maxspace = 300
		if(f != -1)			
			space += 1
			if(space > maxspace - 1)
				space = maxspace - 1
			endif
		endif
		if(!target.IsDead() && !target.IsInCombat() && f != -1)			
			int r2 = Utility.RandomInt(1,maxspace - space)			
			if(r2 != 1)
				return
			endif
						
			VictimMove(victim,target,f,r)			
			space = 0
			debug.notification("There is a Captive near")
		endif
	endif
EndFunction

Function VictimMove(Actor victim,Actor target,int f,int r)	
	aggressors[r].ForceRefTo(target)
	victim.RemoveFromAllFactions()
	Utility.wait(0.5)
	victim.AddToFaction(factions[f])
	victim.AddToFaction(prisonerfaction)
	victim.AddToFaction(registerdfaction)
	victim.SetActorValue("Aggression",0)
	Utility.wait(0.5)
	Outfit of = victim.GetActorBase().GetOutfit()
	victim.SetOutfit(of)
	Utility.wait(0.5)
	victim.MoveTo(target)
	Utility.wait(0.5)
	SetVictim(victim)
EndFunction

Function CheckPlay()
	int n = 0
	Actor player = Game.GetPlayer()
	Actor victim	
	victim = actors[currentvictimnumber].GetActorReference()		
	if(victim && player.GetCurrentLocation() == victim.GetCurrentLocation() && !victim.HasKeyWord(SexLabActive) && victim.IsInFaction(prisonerfaction))
		Actor target = Game.FindRandomActorFromRef(victim,700)		
		if(target == victim || target.IsInFaction(prisonerfaction) || target.IsDead() || target.IsInCombat() || target.HasKeyWord(SexLabActive) || CheckInFaction(target) == -1)
			if(aggressors[currentvictimnumber].GetActorReference())
				target = aggressors[currentvictimnumber].GetActorReference()
			endif
		endif
		int m = 0
		bool x = false				
		if(!target.IsDead() && !target.IsInCombat() && !target.HasKeyWord(SexLabActive))
			sslThreadModel Make = SexLab.NewThread()					
			Actor[] Positions
			int nn = CheckInFaction(target)			
			if(CheckInFaction(target) == 6);dwarvenautomaton
				positions = sslUtility.MakeActorArray(victim)
				if(!Make.AddActors(positions))
					SetVictim(victim)
				else					
					Make.SetHook("CF")	
					RegisterForModEvent("HookAnimationEnd_CF", "AnimationEnd")
					Make.StartThread()
				endif
			else
				int a = 0
				while(a < 2)					
					if(a == 0)
						if(Make.AddActor(victim,true) == -1)
							SetVictim(victim)
							return
						endif
					elseif(a == 1)
						if(Make.AddActor(target,false) == -1)
							SetVictim(victim)
							return						
						endif
					endif
					a += 1
				endwhile					
				Make.SetHook("CF")
				RegisterForModEvent("HookAnimationEnd_CF", "AnimationEnd")
				Make.StartThread()				
			endif					
		else			
			SetIdle(victim)				
		endif			
	endif
EndFunction

event AnimationEnd(int ThreadID, bool HasPlayer)
	sslThreadController Thread = SexLab.GetController(ThreadID)	
	Actor[] Positions = Thread.Positions
	SetVictim(positions[0])		
endEvent

event AnimationEnd3P(int ThreadID, bool HasPlayer)
	sslThreadController Thread = SexLab.GetController(ThreadID)	
	Actor[] Positions = Thread.Positions
	SetVictim(positions[0])
	SetVictim(positions[2])
endEvent

Actor Function SearchVictim2(Actor victim)
	int n = 0
	Actor victim2
	Actor target = aggressors[CheckVictim(victim)].GetActorReference()
	while(n < CFregisteramount.getvalueint())
		victim2 = actors[n].GetActorReference()
		if(victim != victim2 && !victim2.IsDead() && !victim2.IsInCombat() && victim.GetDistance(victim2) < 1000 && aggressors[n] && aggressors[n].GetActorReference() == target)
			return victim2
		endif
		n += 1
	endwhile
	return none
EndFunction

Event OnUpdate()
	CheckMove()
	Utility.wait(2.5)	
	CheckPlay()
	currentvictimnumber += 1
	if(currentvictimnumber == 22)
		ChangePlayerFactionRank()
		currentvictimnumber = 0		
		RegisterForSingleUpdate(2.5)		
	else
		RegisterForSingleUpdate(2.5)	
	endif		
EndEvent

Function SetVictim(Actor victim)
	SetIdle(victim)
	Utility.wait(0.5)
	victim.SetDontMove(true)
	Utility.wait(0.5)
	ActorUtil.AddPackageOverride(victim,donothing,99)
	victim.EvaluatePackage()
	Utility.wait(0.5)	
EndFunction

int Function CheckVictim(Actor act)
	int n = 0
	while(n < actors.length)
		if(actors[n].GetActorReference() == act)			
			return n
		endif
		n += 1
	endwhile
	return -1
EndFunction

Function SetIdle(actor victim)
	Utility.wait(0.5)
	int r
	if(currentvictimnumber == 10)
		r = utility.RandomInt(0,idles.length - 1)
		idlesave[CheckVictim(victim)] = r
	else
		r = idlesave[currentvictimnumber]		
	endif
	victim.PlayIdle(idles[r])
EndFunction

int Function CheckInFaction(Actor act)
	int n = 0
	while(n < factions.length)			
		if(act.IsInFaction(factions[n]))			
			return n
		endif
		n += 1
	endwhile
	return -1
EndFunction

Function Release(Actor victim)
	victim.RemoveFromAllFactions()
	victim.AddToFaction(registerdfaction)
	Utility.wait(0.5)
	Debug.SendAnimationEvent(victim,"IdleForceDefaultState")
	Utility.wait(0.5)	
	victim.SetDontMove(false)
	Utility.wait(0.5)
	ActorUtil.RemovePackageOverride(victim,donothing)
	victim.EvaluatePackage()
	Utility.wait(0.5)
	activepoint += 1

	Actor helper = helpfollower.GetActorReference()

	if(!helper)
		helpfollower.ForceRefTo(victim)
	else
		if(Utility.RandomInt(1,100) < 35)
			helpfollower.ForceRefTo(victim)
		endif
	endif
EndFunction

Function Instead(Actor victim)
	sslThreadModel Make = SexLab.NewThread()
	Actor player = Game.GetPlayer()	
	Actor[] Positions
	
	positions = sslUtility.MakeActorArray(victim,player)
	if(Make.AddActor(positions[0],true) == -1)
		SetVictim(victim)
	else
		if(Make.AddActor(positions[1],false) != -1)
			activepoint += 1
			Make.SetHook("CFInstead")
			RegisterForModEvent("HookAnimationEnd_CFInstead", "AnimationEndInstead")		
			Make.StartThread()				
		endif
	endif	
EndFunction

event AnimationEndInstead(int ThreadID, bool HasPlayer)
	sslThreadController Thread = SexLab.GetController(ThreadID)	
	Actor[] Positions = Thread.Positions
	Release(positions[0])
endEvent

Function RemoveActor(Actor victim)
	int n = CheckVictim(victim)
	SetObjectiveDisplayed(n,false)
	actors[n].Clear()
	victim.RemoveFromAllFactions()
	victim.AddToFaction(potentialfollowerfaction)
	CFregisteramount.SetValueInt(CFregisteramount.getvalueint() - 1)
	debug.notification(CFregisteramount.getvalueint() + "/" + actors.length)
	SortActors(n)
EndFunction

Function SortActors(int index)
	int n = index + 1
	while(n < actors.length)
		if(actors[n].GetActorReference())
			actors[index].ForceRefTo(actors[n].GetActorReference())
			actors[n].Clear()
			SetObjectiveDisplayed(n,false)
			SetObjectiveDisplayed(index,true)
			SortActors(n)
		endif
		n += 1
	endwhile
EndFunction
